\section{Onion Association Search Examples} \label{app:search}
We host the search engine described in Section~\ref{sec:search-engine} on a
Debian VM with 1GB RAM, 20GB SSD, and a single vCPU.  It is available at
\texttt{api.sauteed-onions.org} as well as
\texttt{zpadxxmoi42k45iifrzuktwq
ktihf5didbaec3xo4dhvlw2hj54doiqd.onion}.
Please note that we operate this prototype on a best-effort level until
December, 02022.

An example for the \texttt{search} endpoint is provided in
Figure~\ref{fig:search}, followed by extracting additional certificate
information using the \texttt{get} endpoint in Figure~\ref{fig:get}.  There are
many CT-logged certificates for the same onion association because certificates
are renewed periodically and typically submitted to multiple CT logs.

\begin{figure*}
    \centering
    \begin{lstlisting}
        $ curl -s https://api.sauteed-onions.org/search?in=www.sauteed-onions.org | json_pp
        [
           {
              "identifiers" : [
                 "2",
                 "3",
                 "24",
                 "25",
                 "28",
                 "29",
                 "37"
              ],
              "onion_addr" : "qvrbktnwsztjnbga6yyjbwzsdjw7u5a6vsyzv6hkj75clog4pdvy4cyd.onion",
              "domain_name" : "www.sauteed-onions.org"
           }
        ]
    \end{lstlisting}
    \caption{Find onion associations for \texttt{www.sauteed-onions.org}.}
    \label{fig:search}
\end{figure*}

\begin{figure*}
    \begin{lstlisting}
	$ curl -s https://api.sauteed-onions.org/get?id=2 | json_pp
        {
           "onion_addr" : "qvrbktnwsztjnbga6yyjbwzsdjw7u5a6vsyzv6hkj75clog4pdvy4cyd.onion",
           "domain_name" : "www.sauteed-onions.org",
           "log_id" : "b1N2rDHwMRnYmQCkURX/dxUcEdkCwQApBo2yCJo32RM=",
           "log_index" : 582362461,
           "cert_path" : "db/logs/Mammoth/582362461.pem"
        }
        $ curl -L https://api.sauteed-onions.org/db/logs/Mammoth/582362461.pem | \
	  openssl x509 -text -noout
	...
    \end{lstlisting}
    \caption{Get further information relating to the certificate with identifier ``2''.}
    \label{fig:get}
\end{figure*}

\section{Configuration Example} \label{app:setup}

We used \texttt{certbot} to set up sauteed onions using Let's Encrypt and
\texttt{apache} on a Debian system.  The difference when
compared to the usual \texttt{certbot} instructions is that the \texttt{-d} flag
must be specified to enumerate all SANs as a comma-separated
list~\cite{certbot}.  The domain name with an associated onion address as a
subdomain also needs to be reachable via DNS for Let's Encrypt to perform domain
validation.  Therefore, an appropriate A/AAAA or CNAME record is required.  A
sanity-check for \texttt{www.sauteed-onions.org} would be to verify that
	\texttt{dig qvrbktnwsztjnbga6yyjbwzsdjw7u5a6vsyzv6hk
	j75clog4pdvy4cydonion.www.sauteed-onions.org}
returns the same IP address as
	\texttt{dig www.sauteed-onions.org}
before running
	\texttt{certbot --apache -d~www.sauteed-onions.org,qvrbktnwszt
	jnbga6yyjbwzsdjw7u5a6vsyzv6hkj75clog4pdvy4cydonion.www
	.sauteed-onions.org}.
See \texttt{crt.sh} for an example certificate~\cite{sauteed-onion-cert}.

%%% Local Variables: 
%%% mode: latex 
%%% TeX-master: "../main"
%%% End:          
